--Foreplay Class -- For um, Handling Characters i guess ;)

ForePlay = {}
ForePlay.__index = ForePlay
ForePlay.Character = {}
ForePlay.Character.__index = ForePlay.Character

function ForePlay.createCharacter(x, y, w, h)
	local o = {}
	
	o.images = {
		running = love.graphics.newImage("gfx/miner_frame2.png")
	}
	
	o.status = "grounded"
	
	o.grapple = { status=false, pos=vector(0, 0) , vel=vector(0,0) }
	
	o.body = world:newBody( x, y, 0, 0)
	local s1 = o.body:newCircleShape(0, h/2, w/2)
	local s2 = o.body:newCircleShape(0, -h/2, w/2)
	local s3 = o.body:newRectangleShape(0, 0, w, h, 0)
	local sensor = o.body:newRectangleShape(0, h/1.5, w, 10, 0)
	o.body:setMassFromShapes()
	
	--Setup Shapes
	s1:setFriction(1)
	s2:setFriction(0)
	s1:setMask(3)
	s2:setMask(3)
	s3:setMask(3)
	s1:setCategory(3)
	s2:setCategory(3)
	s3:setCategory(3)
	sensor:setSensor(true)
	
	setmetatable(o, ForePlay.Character)
	
	return o
end

function ForePlay.Character:update(dt)
	local playerMaxSpeed = 50

	--Stop Rotation
	if self.body:getAngle() ~= 0 then
		self.body:setAngle(0)
	end
	local vx, vy = self.body:getLinearVelocity()
	
	--Control
	--Move Left
	if love.keyboard.isDown("a") then
		--self.body:setLinearVelocity(0, vy)
		self.body:applyForce(-playerMaxSpeed, 0)
	end
	--Move Right
	if love.keyboard.isDown("d") then
		self.body:applyForce(playerMaxSpeed, 0)
	end
	
	--Jump
	if love.keyboard.isDown(" ") and self.status == "grounded" then
	end
	
	--Stop
	if not love.keyboard.isDown("a") and not love.keyboard.isDown("d") then
		if self.body:getLinearVelocity() / 5 < -0 or self.body:getLinearVelocity() / 5 > 0 then
			self.body:setLinearVelocity( vx / 5, vy )
		end
	end
	
	--Grapple
	--if grapple.status == false and love.keyboard.isDown("1") then
	--	grapple.status = "searching"
		--grapple.vel = grapple.vel + vector(
	--end
	
	--MaxSpeed
	if vx > playerMaxSpeed then
		self.body:setLinearVelocity(playerMaxSpeed, vy)
	elseif vx < -playerMaxSpeed then
		self.body:setLinearVelocity(-playerMaxSpeed, vy)
	end
end

function ForePlay.Character:draw()
	--Quick ref
	local img = self.images
	local charX = self.body:getLinearVelocity()
	
	love.graphics.print(charX, self.body:getX()+50, self.body:getY() )
	
	if charX < 0 then
		charDir = -1
	else
		charDir = 1
	end
	
	love.graphics.draw(img.running, self.body:getX(), self.body:getY(), 0, charDir, 1, img.running:getWidth()/2, img.running:getHeight()/2 )
end