--Rubbr Man
print("Loaded Rubbrman class")

RubbrMan = {}
RubbrMan.__index = RubbrMan

function RubbrMan.create(x, y, settings)
	local o = {}
	
	
	
	local headSize = 6
	local bodyWidth = 8
	local bodyHeight = 16
	local torsoWidth = 8
	local torsoHeight = 8
	local thighWidth = 4
	local thighHeight = 16
	local legWidth = 4
	local legHeight = 16
	
		
	o.bodies = {
		head = fizz.newBody(world, x, y-bodyHeight/2-headSize, 0, 0),
		neck = fizz.newBody(world, x, y-bodyHeight/2, 0, 0),
		body = fizz.newBody(world, x, y, 0, 0),
		torso = fizz.newBody(world, x, y+bodyHeight/2+torsoHeight/2, 0, 0),
		thigh = fizz.newBody(world, x, y+bodyHeight/2+torsoHeight+thighHeight/2, 0, 0),
		leg = fizz.newBody(world, x, y+bodyHeight/2+torsoHeight+thighHeight+legHeight/2, 0, 0)
	}
	
	o.shapes = {
		head = o.bodies.head:newCircleShape(0, 0, headSize),
		neck = o.bodies.neck:newRectangleShape(0, 0, headSize/1.5, headSize/2, 0),
		body = o.bodies.body:newRectangleShape(0, 0, bodyWidth, bodyHeight, 0),
		torso = o.bodies.torso:newRectangleShape(0, 0, torsoWidth, torsoHeight, 0),
		thigh = o.bodies.thigh:newRectangleShape(0, 0, thighWidth, thighHeight, 0),
		leg = o.bodies.leg:newRectangleShape(0, 0, legWidth, legHeight, 0)
	}
	
	o.joints = {
		head = o.bodies.head:newRevoluteJoint(o.bodies.neck, 0, headSize/2),
		neck = o.bodies.neck:newRevoluteJoint(o.bodies.body, 0, 0),
		torso = o.bodies.torso:newRevoluteJoint(o.bodies.body, 0, -torsoHeight/2),
		thigh = o.bodies.thigh:newRevoluteJoint(o.bodies.torso, 0, -thighHeight/2),
		leg = o.bodies.leg:newRevoluteJoint(o.bodies.thigh, 0, -legHeight/2)
	}
	
	--Setup Joints
	o.joints.torso.joint:setMotorEnabled(true)
	o.joints.torso.joint:setLimitsEnabled(true)
	o.joints.torso.joint:setLimits(math.rad(-40), math.rad(40))
	
	o.joints.thigh.joint:setLimitsEnabled(true)
	o.joints.thigh.joint:setLimits(math.rad(-45), math.rad(140))
	
	o.joints.leg.joint:setLimitsEnabled(true)
	o.joints.leg.joint:setLimits(math.rad(-160), math.rad(0))
	
	--Set all bodies mass automatically
	for i, limb in pairs(o.bodies) do
		if limb ~= o.bodies.body then
		limb:setMassFromShapes()
		end
	end
	
	setmetatable(o, Rubbrman)
	
	return o
end